# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetInfrastructuresResult',
    'AwaitableGetInfrastructuresResult',
    'get_infrastructures',
    'get_infrastructures_output',
]

@pulumi.output_type
class GetInfrastructuresResult:
    """
    A collection of values returned by getInfrastructures.
    """
    def __init__(__self__, datas=None, id=None):
        if datas and not isinstance(datas, list):
            raise TypeError("Expected argument 'datas' to be a list")
        pulumi.set(__self__, "datas", datas)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def datas(self) -> Sequence['outputs.GetInfrastructuresDataResult']:
        return pulumi.get(self, "datas")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")


class AwaitableGetInfrastructuresResult(GetInfrastructuresResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInfrastructuresResult(
            datas=self.datas,
            id=self.id)


def get_infrastructures(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInfrastructuresResult:
    """
    `get_infrastructures` retrieves a list of infrastructures in Duplo.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_duplocloud as duplocloud

    # Retrieve a list of all infrastructures
    all = duplocloud.get_infrastructures()
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('duplocloud:index/getInfrastructures:getInfrastructures', __args__, opts=opts, typ=GetInfrastructuresResult).value

    return AwaitableGetInfrastructuresResult(
        datas=pulumi.get(__ret__, 'datas'),
        id=pulumi.get(__ret__, 'id'))
def get_infrastructures_output(opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetInfrastructuresResult]:
    """
    `get_infrastructures` retrieves a list of infrastructures in Duplo.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_duplocloud as duplocloud

    # Retrieve a list of all infrastructures
    all = duplocloud.get_infrastructures()
    ```
    """
    __args__ = dict()
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('duplocloud:index/getInfrastructures:getInfrastructures', __args__, opts=opts, typ=GetInfrastructuresResult)
    return __ret__.apply(lambda __response__: GetInfrastructuresResult(
        datas=pulumi.get(__response__, 'datas'),
        id=pulumi.get(__response__, 'id')))
