# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetNativeHostImagesResult',
    'AwaitableGetNativeHostImagesResult',
    'get_native_host_images',
    'get_native_host_images_output',
]

@pulumi.output_type
class GetNativeHostImagesResult:
    """
    A collection of values returned by getNativeHostImages.
    """
    def __init__(__self__, id=None, images=None, tenant_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if images and not isinstance(images, list):
            raise TypeError("Expected argument 'images' to be a list")
        pulumi.set(__self__, "images", images)
        if tenant_id and not isinstance(tenant_id, str):
            raise TypeError("Expected argument 'tenant_id' to be a str")
        pulumi.set(__self__, "tenant_id", tenant_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def images(self) -> Sequence['outputs.GetNativeHostImagesImageResult']:
        """
        The list of images for this tenant.
        """
        return pulumi.get(self, "images")

    @property
    @pulumi.getter(name="tenantId")
    def tenant_id(self) -> str:
        """
        The tenant ID
        """
        return pulumi.get(self, "tenant_id")


class AwaitableGetNativeHostImagesResult(GetNativeHostImagesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetNativeHostImagesResult(
            id=self.id,
            images=self.images,
            tenant_id=self.tenant_id)


def get_native_host_images(tenant_id: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetNativeHostImagesResult:
    """
    `get_native_host_images` retrieves a list of applicable images for a given tenant.


    :param str tenant_id: The tenant ID
    """
    __args__ = dict()
    __args__['tenantId'] = tenant_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('duplocloud:index/getNativeHostImages:getNativeHostImages', __args__, opts=opts, typ=GetNativeHostImagesResult).value

    return AwaitableGetNativeHostImagesResult(
        id=pulumi.get(__ret__, 'id'),
        images=pulumi.get(__ret__, 'images'),
        tenant_id=pulumi.get(__ret__, 'tenant_id'))
def get_native_host_images_output(tenant_id: Optional[pulumi.Input[str]] = None,
                                  opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetNativeHostImagesResult]:
    """
    `get_native_host_images` retrieves a list of applicable images for a given tenant.


    :param str tenant_id: The tenant ID
    """
    __args__ = dict()
    __args__['tenantId'] = tenant_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('duplocloud:index/getNativeHostImages:getNativeHostImages', __args__, opts=opts, typ=GetNativeHostImagesResult)
    return __ret__.apply(lambda __response__: GetNativeHostImagesResult(
        id=pulumi.get(__response__, 'id'),
        images=pulumi.get(__response__, 'images'),
        tenant_id=pulumi.get(__response__, 'tenant_id')))
