# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetPlanKmsKeyV2Result',
    'AwaitableGetPlanKmsKeyV2Result',
    'get_plan_kms_key_v2',
    'get_plan_kms_key_v2_output',
]

@pulumi.output_type
class GetPlanKmsKeyV2Result:
    """
    A collection of values returned by getPlanKmsKeyV2.
    """
    def __init__(__self__, id=None, kms_keys=None, plan_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if kms_keys and not isinstance(kms_keys, list):
            raise TypeError("Expected argument 'kms_keys' to be a list")
        pulumi.set(__self__, "kms_keys", kms_keys)
        if plan_id and not isinstance(plan_id, str):
            raise TypeError("Expected argument 'plan_id' to be a str")
        pulumi.set(__self__, "plan_id", plan_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="kmsKeys")
    def kms_keys(self) -> Sequence['outputs.GetPlanKmsKeyV2KmsKeyResult']:
        """
        The list of kms keys for this plan.
        """
        return pulumi.get(self, "kms_keys")

    @property
    @pulumi.getter(name="planId")
    def plan_id(self) -> str:
        """
        The plan ID
        """
        return pulumi.get(self, "plan_id")


class AwaitableGetPlanKmsKeyV2Result(GetPlanKmsKeyV2Result):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPlanKmsKeyV2Result(
            id=self.id,
            kms_keys=self.kms_keys,
            plan_id=self.plan_id)


def get_plan_kms_key_v2(plan_id: Optional[str] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPlanKmsKeyV2Result:
    """
    `get_plan_kms_key` retrieves a list of kms keys for a given plan.


    :param str plan_id: The plan ID
    """
    __args__ = dict()
    __args__['planId'] = plan_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('duplocloud:index/getPlanKmsKeyV2:getPlanKmsKeyV2', __args__, opts=opts, typ=GetPlanKmsKeyV2Result).value

    return AwaitableGetPlanKmsKeyV2Result(
        id=pulumi.get(__ret__, 'id'),
        kms_keys=pulumi.get(__ret__, 'kms_keys'),
        plan_id=pulumi.get(__ret__, 'plan_id'))
def get_plan_kms_key_v2_output(plan_id: Optional[pulumi.Input[str]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetPlanKmsKeyV2Result]:
    """
    `get_plan_kms_key` retrieves a list of kms keys for a given plan.


    :param str plan_id: The plan ID
    """
    __args__ = dict()
    __args__['planId'] = plan_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('duplocloud:index/getPlanKmsKeyV2:getPlanKmsKeyV2', __args__, opts=opts, typ=GetPlanKmsKeyV2Result)
    return __ret__.apply(lambda __response__: GetPlanKmsKeyV2Result(
        id=pulumi.get(__response__, 'id'),
        kms_keys=pulumi.get(__response__, 'kms_keys'),
        plan_id=pulumi.get(__response__, 'plan_id')))
