# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetPlanNatGatewaysResult',
    'AwaitableGetPlanNatGatewaysResult',
    'get_plan_nat_gateways',
    'get_plan_nat_gateways_output',
]

@pulumi.output_type
class GetPlanNatGatewaysResult:
    """
    A collection of values returned by getPlanNatGateways.
    """
    def __init__(__self__, id=None, nat_gateways=None, plan_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if nat_gateways and not isinstance(nat_gateways, list):
            raise TypeError("Expected argument 'nat_gateways' to be a list")
        pulumi.set(__self__, "nat_gateways", nat_gateways)
        if plan_id and not isinstance(plan_id, str):
            raise TypeError("Expected argument 'plan_id' to be a str")
        pulumi.set(__self__, "plan_id", plan_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="natGateways")
    def nat_gateways(self) -> Sequence['outputs.GetPlanNatGatewaysNatGatewayResult']:
        """
        The list of NAT gateways for this plan.
        """
        return pulumi.get(self, "nat_gateways")

    @property
    @pulumi.getter(name="planId")
    def plan_id(self) -> str:
        """
        The plan ID
        """
        return pulumi.get(self, "plan_id")


class AwaitableGetPlanNatGatewaysResult(GetPlanNatGatewaysResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPlanNatGatewaysResult(
            id=self.id,
            nat_gateways=self.nat_gateways,
            plan_id=self.plan_id)


def get_plan_nat_gateways(plan_id: Optional[str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPlanNatGatewaysResult:
    """
    `get_plan_nat_gateways` retrieves a list of NAT gateways for a given plan.


    :param str plan_id: The plan ID
    """
    __args__ = dict()
    __args__['planId'] = plan_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('duplocloud:index/getPlanNatGateways:getPlanNatGateways', __args__, opts=opts, typ=GetPlanNatGatewaysResult).value

    return AwaitableGetPlanNatGatewaysResult(
        id=pulumi.get(__ret__, 'id'),
        nat_gateways=pulumi.get(__ret__, 'nat_gateways'),
        plan_id=pulumi.get(__ret__, 'plan_id'))
def get_plan_nat_gateways_output(plan_id: Optional[pulumi.Input[str]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetPlanNatGatewaysResult]:
    """
    `get_plan_nat_gateways` retrieves a list of NAT gateways for a given plan.


    :param str plan_id: The plan ID
    """
    __args__ = dict()
    __args__['planId'] = plan_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('duplocloud:index/getPlanNatGateways:getPlanNatGateways', __args__, opts=opts, typ=GetPlanNatGatewaysResult)
    return __ret__.apply(lambda __response__: GetPlanNatGatewaysResult(
        id=pulumi.get(__response__, 'id'),
        nat_gateways=pulumi.get(__response__, 'nat_gateways'),
        plan_id=pulumi.get(__response__, 'plan_id')))
