# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetTenantExternalSubnetsResult',
    'AwaitableGetTenantExternalSubnetsResult',
    'get_tenant_external_subnets',
    'get_tenant_external_subnets_output',
]

@pulumi.output_type
class GetTenantExternalSubnetsResult:
    """
    A collection of values returned by getTenantExternalSubnets.
    """
    def __init__(__self__, id=None, subnet_ids=None, tenant_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if subnet_ids and not isinstance(subnet_ids, list):
            raise TypeError("Expected argument 'subnet_ids' to be a list")
        pulumi.set(__self__, "subnet_ids", subnet_ids)
        if tenant_id and not isinstance(tenant_id, str):
            raise TypeError("Expected argument 'tenant_id' to be a str")
        pulumi.set(__self__, "tenant_id", tenant_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="subnetIds")
    def subnet_ids(self) -> Sequence[str]:
        """
        The list of subnet IDs.
        """
        return pulumi.get(self, "subnet_ids")

    @property
    @pulumi.getter(name="tenantId")
    def tenant_id(self) -> str:
        """
        The GUID of the tenant.
        """
        return pulumi.get(self, "tenant_id")


class AwaitableGetTenantExternalSubnetsResult(GetTenantExternalSubnetsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTenantExternalSubnetsResult(
            id=self.id,
            subnet_ids=self.subnet_ids,
            tenant_id=self.tenant_id)


def get_tenant_external_subnets(tenant_id: Optional[str] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTenantExternalSubnetsResult:
    """
    The `get_tenant_external_subnets` data source retrieves a list of tenant's external subnet IDs.


    :param str tenant_id: The GUID of the tenant.
    """
    __args__ = dict()
    __args__['tenantId'] = tenant_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('duplocloud:index/getTenantExternalSubnets:getTenantExternalSubnets', __args__, opts=opts, typ=GetTenantExternalSubnetsResult).value

    return AwaitableGetTenantExternalSubnetsResult(
        id=pulumi.get(__ret__, 'id'),
        subnet_ids=pulumi.get(__ret__, 'subnet_ids'),
        tenant_id=pulumi.get(__ret__, 'tenant_id'))
def get_tenant_external_subnets_output(tenant_id: Optional[pulumi.Input[str]] = None,
                                       opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetTenantExternalSubnetsResult]:
    """
    The `get_tenant_external_subnets` data source retrieves a list of tenant's external subnet IDs.


    :param str tenant_id: The GUID of the tenant.
    """
    __args__ = dict()
    __args__['tenantId'] = tenant_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('duplocloud:index/getTenantExternalSubnets:getTenantExternalSubnets', __args__, opts=opts, typ=GetTenantExternalSubnetsResult)
    return __ret__.apply(lambda __response__: GetTenantExternalSubnetsResult(
        id=pulumi.get(__response__, 'id'),
        subnet_ids=pulumi.get(__response__, 'subnet_ids'),
        tenant_id=pulumi.get(__response__, 'tenant_id')))
