# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['PlanConfigsArgs', 'PlanConfigs']

@pulumi.input_type
class PlanConfigsArgs:
    def __init__(__self__, *,
                 plan_id: pulumi.Input[str],
                 config: Optional[pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]]] = None,
                 delete_unspecified_configs: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a PlanConfigs resource.
        :param pulumi.Input[str] plan_id: The ID of the plan to configure.
        :param pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]] config: A list of configs to manage.
        :param pulumi.Input[bool] delete_unspecified_configs: Whether or not this resource should delete any configs not specified by this resource. **WARNING:**  It is not recommended to change the default value of `false`. Defaults to `false`.
        """
        pulumi.set(__self__, "plan_id", plan_id)
        if config is not None:
            pulumi.set(__self__, "config", config)
        if delete_unspecified_configs is not None:
            pulumi.set(__self__, "delete_unspecified_configs", delete_unspecified_configs)

    @property
    @pulumi.getter(name="planId")
    def plan_id(self) -> pulumi.Input[str]:
        """
        The ID of the plan to configure.
        """
        return pulumi.get(self, "plan_id")

    @plan_id.setter
    def plan_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "plan_id", value)

    @property
    @pulumi.getter
    def config(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]]]:
        """
        A list of configs to manage.
        """
        return pulumi.get(self, "config")

    @config.setter
    def config(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]]]):
        pulumi.set(self, "config", value)

    @property
    @pulumi.getter(name="deleteUnspecifiedConfigs")
    def delete_unspecified_configs(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether or not this resource should delete any configs not specified by this resource. **WARNING:**  It is not recommended to change the default value of `false`. Defaults to `false`.
        """
        return pulumi.get(self, "delete_unspecified_configs")

    @delete_unspecified_configs.setter
    def delete_unspecified_configs(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "delete_unspecified_configs", value)


@pulumi.input_type
class _PlanConfigsState:
    def __init__(__self__, *,
                 config: Optional[pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]]] = None,
                 configs: Optional[pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]]] = None,
                 delete_unspecified_configs: Optional[pulumi.Input[bool]] = None,
                 plan_id: Optional[pulumi.Input[str]] = None,
                 specified_configs: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering PlanConfigs resources.
        :param pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]] config: A list of configs to manage.
        :param pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]] configs: A complete list of configs for this plan, even ones not being managed by this resource.
        :param pulumi.Input[bool] delete_unspecified_configs: Whether or not this resource should delete any configs not specified by this resource. **WARNING:**  It is not recommended to change the default value of `false`. Defaults to `false`.
        :param pulumi.Input[str] plan_id: The ID of the plan to configure.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] specified_configs: A list of config keys being managed by this resource.
        """
        if config is not None:
            pulumi.set(__self__, "config", config)
        if configs is not None:
            pulumi.set(__self__, "configs", configs)
        if delete_unspecified_configs is not None:
            pulumi.set(__self__, "delete_unspecified_configs", delete_unspecified_configs)
        if plan_id is not None:
            pulumi.set(__self__, "plan_id", plan_id)
        if specified_configs is not None:
            pulumi.set(__self__, "specified_configs", specified_configs)

    @property
    @pulumi.getter
    def config(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]]]:
        """
        A list of configs to manage.
        """
        return pulumi.get(self, "config")

    @config.setter
    def config(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]]]):
        pulumi.set(self, "config", value)

    @property
    @pulumi.getter
    def configs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]]]:
        """
        A complete list of configs for this plan, even ones not being managed by this resource.
        """
        return pulumi.get(self, "configs")

    @configs.setter
    def configs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['PlanConfigsConfigArgs']]]]):
        pulumi.set(self, "configs", value)

    @property
    @pulumi.getter(name="deleteUnspecifiedConfigs")
    def delete_unspecified_configs(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether or not this resource should delete any configs not specified by this resource. **WARNING:**  It is not recommended to change the default value of `false`. Defaults to `false`.
        """
        return pulumi.get(self, "delete_unspecified_configs")

    @delete_unspecified_configs.setter
    def delete_unspecified_configs(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "delete_unspecified_configs", value)

    @property
    @pulumi.getter(name="planId")
    def plan_id(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the plan to configure.
        """
        return pulumi.get(self, "plan_id")

    @plan_id.setter
    def plan_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "plan_id", value)

    @property
    @pulumi.getter(name="specifiedConfigs")
    def specified_configs(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        A list of config keys being managed by this resource.
        """
        return pulumi.get(self, "specified_configs")

    @specified_configs.setter
    def specified_configs(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "specified_configs", value)


class PlanConfigs(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config: Optional[pulumi.Input[Sequence[pulumi.Input[Union['PlanConfigsConfigArgs', 'PlanConfigsConfigArgsDict']]]]] = None,
                 delete_unspecified_configs: Optional[pulumi.Input[bool]] = None,
                 plan_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        `PlanConfigs` manages the list of configs avaialble to a plan in Duplo.

        This resource allows you take control of individual configs for a specific plan.

        ## Import

        ```sh
        $ pulumi import duplocloud:index/planConfigs:PlanConfigs myplan PLAN_ID
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['PlanConfigsConfigArgs', 'PlanConfigsConfigArgsDict']]]] config: A list of configs to manage.
        :param pulumi.Input[bool] delete_unspecified_configs: Whether or not this resource should delete any configs not specified by this resource. **WARNING:**  It is not recommended to change the default value of `false`. Defaults to `false`.
        :param pulumi.Input[str] plan_id: The ID of the plan to configure.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: PlanConfigsArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        `PlanConfigs` manages the list of configs avaialble to a plan in Duplo.

        This resource allows you take control of individual configs for a specific plan.

        ## Import

        ```sh
        $ pulumi import duplocloud:index/planConfigs:PlanConfigs myplan PLAN_ID
        ```

        :param str resource_name: The name of the resource.
        :param PlanConfigsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(PlanConfigsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config: Optional[pulumi.Input[Sequence[pulumi.Input[Union['PlanConfigsConfigArgs', 'PlanConfigsConfigArgsDict']]]]] = None,
                 delete_unspecified_configs: Optional[pulumi.Input[bool]] = None,
                 plan_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = PlanConfigsArgs.__new__(PlanConfigsArgs)

            __props__.__dict__["config"] = config
            __props__.__dict__["delete_unspecified_configs"] = delete_unspecified_configs
            if plan_id is None and not opts.urn:
                raise TypeError("Missing required property 'plan_id'")
            __props__.__dict__["plan_id"] = plan_id
            __props__.__dict__["configs"] = None
            __props__.__dict__["specified_configs"] = None
        super(PlanConfigs, __self__).__init__(
            'duplocloud:index/planConfigs:PlanConfigs',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config: Optional[pulumi.Input[Sequence[pulumi.Input[Union['PlanConfigsConfigArgs', 'PlanConfigsConfigArgsDict']]]]] = None,
            configs: Optional[pulumi.Input[Sequence[pulumi.Input[Union['PlanConfigsConfigArgs', 'PlanConfigsConfigArgsDict']]]]] = None,
            delete_unspecified_configs: Optional[pulumi.Input[bool]] = None,
            plan_id: Optional[pulumi.Input[str]] = None,
            specified_configs: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'PlanConfigs':
        """
        Get an existing PlanConfigs resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[Union['PlanConfigsConfigArgs', 'PlanConfigsConfigArgsDict']]]] config: A list of configs to manage.
        :param pulumi.Input[Sequence[pulumi.Input[Union['PlanConfigsConfigArgs', 'PlanConfigsConfigArgsDict']]]] configs: A complete list of configs for this plan, even ones not being managed by this resource.
        :param pulumi.Input[bool] delete_unspecified_configs: Whether or not this resource should delete any configs not specified by this resource. **WARNING:**  It is not recommended to change the default value of `false`. Defaults to `false`.
        :param pulumi.Input[str] plan_id: The ID of the plan to configure.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] specified_configs: A list of config keys being managed by this resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _PlanConfigsState.__new__(_PlanConfigsState)

        __props__.__dict__["config"] = config
        __props__.__dict__["configs"] = configs
        __props__.__dict__["delete_unspecified_configs"] = delete_unspecified_configs
        __props__.__dict__["plan_id"] = plan_id
        __props__.__dict__["specified_configs"] = specified_configs
        return PlanConfigs(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def config(self) -> pulumi.Output[Optional[Sequence['outputs.PlanConfigsConfig']]]:
        """
        A list of configs to manage.
        """
        return pulumi.get(self, "config")

    @property
    @pulumi.getter
    def configs(self) -> pulumi.Output[Sequence['outputs.PlanConfigsConfig']]:
        """
        A complete list of configs for this plan, even ones not being managed by this resource.
        """
        return pulumi.get(self, "configs")

    @property
    @pulumi.getter(name="deleteUnspecifiedConfigs")
    def delete_unspecified_configs(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether or not this resource should delete any configs not specified by this resource. **WARNING:**  It is not recommended to change the default value of `false`. Defaults to `false`.
        """
        return pulumi.get(self, "delete_unspecified_configs")

    @property
    @pulumi.getter(name="planId")
    def plan_id(self) -> pulumi.Output[str]:
        """
        The ID of the plan to configure.
        """
        return pulumi.get(self, "plan_id")

    @property
    @pulumi.getter(name="specifiedConfigs")
    def specified_configs(self) -> pulumi.Output[Sequence[str]]:
        """
        A list of config keys being managed by this resource.
        """
        return pulumi.get(self, "specified_configs")

